      PROGRAM DRIVER
C
C**** driver intended for a complex non-Hermitian matrix ***************
C
      INTEGER   MAXN,MAXW
C
C.... maximum dimension of the matrix ..................................
C
      PARAMETER (MAXN=  150)
C
C.... maximum dimension of (W), the Lanczos work array .................
C
      PARAMETER (MAXW= 8000)
C
C***********************************************************************
C
C-----------------------------------------------------------------------
      INTEGER          COLUMN,I,J,LFLAG,INFO(4),LPRNT,LPSET(5),
     &                 N,NREIG,NSTEPS,ROW
C-----------------------------------------------------------------------
      COMPLEX*16       BASIS(MAXN,MAXN),CMPLX0,CMPLX1,H(MAXN,MAXN),
     &                 Q(MAXN),R(MAXN),X(MAXN,MAXN)
C-----------------------------------------------------------------------
      DOUBLE PRECISION EIG(MAXN),HNRM,IPART,RNRM(MAXN),RPART,W(MAXW)
C-----------------------------------------------------------------------
C
      WRITE (*,2000)
C
      N = 0
C
      CMPLX0 = ( 0.0D0, 0.0D0 )
      CMPLX1 = ( 1.0D0, 0.0D0 )
C
C.... read data ........................................................
C
      CALL  ZSCAL (MAXN     ,CMPLX0,Q,1)
      CALL  ZSCAL (MAXN*MAXN,CMPLX0,H,1)
C
      OPEN  (UNIT=10,ERR=1,FILE='driver_3.dat')
      OPEN  (UNIT=11,ERR=2,FILE='driver_3.par')
C
      DO 010 I=1,MAXN
         DO 020 J=1,MAXN
            READ  (UNIT=10,FMT=*,END=030) ROW,COLUMN,RPART,IPART
            N = MAX0(ROW,COLUMN,N)
            IF ( N .GT. MAXN ) THEN
               WRITE (*,*) 'the dimension of the matrix is too big'
               STOP
            ELSE
               H(ROW,COLUMN) = DCMPLX(RPART,IPART)
            END IF
  020    CONTINUE
  010 CONTINUE
C
  030 CONTINUE
C
      READ  (UNIT=11,ERR=1,FMT='(   I5)') NREIG,NSTEPS,LPRNT 
C
      CLOSE (UNIT=10,ERR=1)
      CLOSE (UNIT=11,ERR=2)
C
      IF ( (NSTEPS+10)*NSTEPS .GT. MAXW ) THEN
         WRITE (*,*) 'NSTEPS is too big'
         STOP
      END IF
C
C.......................................................................
C
      LFLAG = 0
      HNRM  = 0.0D0
C
      LPSET(1) = N*2
      LPSET(2) = NREIG
      LPSET(3) = NSTEPS
      LPSET(4) = LPRNT
      LPSET(5) = MAXN
C
  050 CONTINUE
C
      CALL HLZDRD (LFLAG,LPSET,INFO,HNRM,EIG,RNRM,W,Q,R,BASIS,X)
C
      IF      (LFLAG.LT.0) THEN
           WRITE (*,2100) INFO(1),INFO(2),INFO(3),INFO(4)
           STOP
      ELSE IF (LFLAG.EQ.1) THEN
           CALL ZGEMV ('N',N,N,CMPLX1,H,MAXN,Q(1  ),1,CMPLX0,R(1+N),1)
           CALL ZGEMV ('C',N,N,CMPLX1,H,MAXN,Q(1+N),1,CMPLX0,R(1  ),1)
           GO TO 050
      END IF
C
      CALL HLZDRD (   3,LPSET,INFO,HNRM,EIG,RNRM,W,Q,R,BASIS,X)
C
      WRITE (*,2200) INFO(1),INFO(2),INFO(3),INFO(4)
C
      STOP
    1 WRITE (*,'(/A)') 'IO error, verify file driver_3.dat'
      STOP
    2 WRITE (*,'(/A)') 'IO error, verify file driver_3.par'
      STOP
C
 2000 FORMAT (/'+---------------------------------------------+',
     &        /'|                                             |',
     &        /'|               driver model 3                |',
     &        /'|                                             |',
     &        /'|                   | 0  A |                  |',
     &        /'|               R = |      |Q                 |',
     &        /'|                   | A* 0 |                  |',
     &        /'|                                             |',
     &        /'+---------------------------------------------+'//)
 2100 FORMAT (/'abnormal exit, execution finished       [',4i5,' ]')
 2200 FORMAT (/'standard exit, execution finished       [',4i5,' ]')
C
C**** end of DRIVER ****************************************************
C
      END
